;(setq lasm_expr *t*)
;       -,
;       (   get-label).
;  ,  .
;       ,    
;    .       .
;    ""  ,      
;   .     , .

; +,-,/,*,\(%),&,|,^,~,<<,>>
; lables: (asm-get-label "name")
; hex: #num
; oct: @num
; bin: %num

(defun << (a b) (bad-syntax "<<: not yet"))
(defun >> (a b) (bad-syntax ">>: not yet"))

(defun str-as-num (str)
 ; convert "n" and "nn" to byte and word, quote others
  (switch (length str)
    0 (bad-syntax "empty string")
    1 (nth str 1)
    2 (| (* (nth str 1) 256) (nth str 2))
    (|| "\"" str "\"")
  )
)

(defun expr-prefix (str |
    res ops token
    collect bin-dig? oct-dig? dec-dig? hex-dig?
    next-token match-token expect-token
    find-op
    term expr
  )

  (setq
    ops '(
      (2 &   ::&)
      (3 |   ::|)
      (3 ^   ::^)
      (4 <<  ::<<)
      (4 >>  ::>>)
      (5 *   ::*)
      (5 /   ::idiv)
      (5 \   ::mod)
      (6 +   ::+)
      (6 -   ::-)
    )
  )

  (defun find-op (name | n)
    ;(lprintln "name" name)
    (setq n ops)
    (if (int? name)
          (while (land n (<> (nth (cadar n) 1) name))
            ;(lprintln (cadar n))
            (setq n (cdr n))
          )
      (while (land n (<> (cadar n) name)) (setq n (cdr n)))
    )
    (if n (setq n (car n)))
    ;(lprintln "name" name "op" n)
    n
  )

  (defun bin-dig? (ch)  (within ch 48 49))
  (defun oct-dig? (ch)  (within ch 48 55))
  (defun dec-dig? (ch)  (within ch 48 57))
  (defun hex-dig? (ch)
    (lor (within ch 48 57)
         (within ch 65 70)
         (within ch 97 122)
    )
  )

  (defun collect (prim skip-1st | n)
    ;(if skip-1st (setq str (str-mid str 2)))
    ;(lprintln "collector" prim)
    (setq n (if skip-1st 2 1))
    (while (land (<= n (length str)) (prim (nth str n)))  (setq n (incr n)))
    (if (< n (if skip-1st 3 2)) (bad-syntax (|| "invalid token (0): " str)))
    (setq token (str-mid str 1 (decr n)))
    (setq str (str-mid str n))
    ;(lprintln "collected" token)
    token
  )

  (defun next-token (| ch)
   ;  -,   <token>
    ;(lprintln "str" str)
    (setq str (trim-left str))
    (setq ch (nth str 1))
    ;(lprintln "ch" ch "str" str " -- " (is-number ch))
    (if
      (null? ch) (setq token "")
      (= ch 60) ; <
        (if
          (= (nth str 2) 60) ; <
            (setq  token "<<"  str (str-mid str 3))
         (bad-syntax (|| "invalid token (1): " str))
        )
      (= ch 62) ; >
        (if
          (= (nth str 2) 62) ; >
            (setq  token ">>"  str (str-mid str 3))
         (bad-syntax (|| "invalid token (2): " str))
        )
      (lor (= ch 40) (= ch 41)) ; ()
        (setq token (str-mid str 1 1)  str (str-mid str 2))
      (= ch 37)/* % */  (setq token (toint (collect bin-dig? *t*)))
      (= ch 64)/* @ */  (setq token (toint (collect oct-dig? *t*)))
      (= ch 35)/* # */  (setq token (toint (collect hex-dig? *t*)))
      (= ch 36)/* $ */  (setq token (str-mid str 1 1)  str (str-mid str 2))
      (= ch 34) ; "
        (begin
          (setq str (str-mid str 2))
          (collect is-nquote *f*)
          (if
            (land (not-empty-str? str)  (= (nth str 1) 34))
              (setq str (str-mid str 2))
           (bad-syntax "unfinished string")
          )
          (setq token (str-as-num token))
          ;(lprintln "tk" token "str" str)
        )
      (is-number ch)  (setq token (toint (collect dec-dig? *f*)))
      (is-alpha ch)  (collect is-alphanum *f*)
      (= ch 46)/* . */  (collect is-alphanum *t*)
      (find-op ch) (setq token (str-mid str 1 1)  str (str-mid str 2))
     (bad-syntax (|| "invalid token (3): " str))
    )
    ;(lprintln "token" token (string? token))
    (if
      (land (string? token) (not-empty-str? token) (<> (nth token 1) 34))
        (setq token (lower-case token))
    )
    ;(lprintln "token" token (string? token))
    ;(lprintln "alist" *alist*)
    token
  )

  (defun match-token (tk)
    (if (eq tk token) (setq tk (next-token) tk *t*)
     *f*
    )
  )

  (defun expect-token (tk)
    (if (eq tk token) (setq tk (next-token) tk *t*)
     (bad-syntax (|| "expected: \"" tk "\""))
    )
  )

  (defun term (| r)
   ;  -
    (if
      (land (string? token) (zero? (length token)))  (setq r *nil*)
      (match-token "(")
        (begin (setq r (expr 9)) (expect-token ")"))
      (match-token "-")  (setq r (list '- 0 (term)))
      (match-token "+")  (setq r (term))
      (match-token "~")  (setq r (list '~ 0 (term)))
      (number? token)  (begin (setq r token) (next-token))
     ;(begin (setq r (list 'asm-get-label (list 'quote token))) (next-token))
      (= (nth token 1) 34) (begin (setq r token) (next-token))
     (begin (setq r (list 'asm-get-label (list 'quote token))) (next-token))
    )
    ;(lprintln "term:" r)
    r
  )

  (defun expr (prio | o0 opp wc op)
    (if (< prio 2) (term)
     (begin
       ;(lprintln " token" token)
       (setq o0 (expr (decr prio))  wc *t*)
       ;(lprintln "expr:" "prio" prio "o0" o0)
       (while wc
         ;(lprintln " token" token)
         (if (string? token) (setq op (find-op token))  (setq op "!"))
         ;(lprintln " op" op)
         (if (land op  (= (car op) prio))
           (begin
             (next-token)
             (if (setq opp (find-symbol (caddr op)))
                   (setq opp (cdr opp))
               (setq opp (caddr op))
             )
             (setq o0
               (list
                 ;(caddr op)  ; op
                 opp
                 o0
                 (expr prio)
               )
             )
           )
          (setq wc *f*)
         )
       )
       o0
     )
    )
  )

  (next-token)
  ;(lprintln "token" token)
  (expr 9)
)
