{.$INCLUDE options.inc}
unit aSatanU;

interface

const
  monthStrings: array [1..12] of string[3] = (
    'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');


type
  TMonthStrType = (tmsArab, tmsRome, tmsString);


function Arab2Rome (i: Integer): string;
function DateToSatan (year, month, day: Integer; monthStrType: TMonthStrType; delChar: Char): string;


implementation


function Str2 (i: Integer): string; {$IFDEF VER180}inline;{$ENDIF}
begin
  Str(i:2, result);
  if i < 10 then result[1] := '0';
end;

function Arab2Rome (i: Integer): string;
// this was rewritten with arrays. i like it this way :-)
const
  rPosCount = 13;
  rPos: array [0..rPosCount-1] of Integer = (
    1000, 900, 500, 400, 100, 90, 50, 40, 10, 9, 5, 4, 1);
  rName: array [0..rPosCount-1] of string = (
    'M', 'CM', 'D', 'CD', 'C', 'XC', 'L', 'XL', 'X', 'IX', 'V', 'IV', 'I');
var
  f: Integer;
begin
  result := '';
  for f := 0 to rPosCount - 1 do
  begin
    while i >= rPos[f] do
    begin
      result := result+rName[f];
      Dec(i, rPos[f]);
    end;
  end;
end;

function DateToSatan (year, month, day: Integer; monthStrType: TMonthStrType; delChar: Char): string;
// and this is completely mine except the date of the 1 A.S. :-))
// NO CHECKS!!!
begin
  result := Str2(day) + delChar;
  if month < 1 then month := 1  else if month > 12 then month := 12;

  case monthStrType of
    tmsArab: result := result+Str2(month);
    tmsRome: result := result+Arab2Rome(month);
    else result := result+monthStrings[month];
  end;

  Dec(year, 1965);
  if year < 1 then Dec(year);
  result := result+delChar+Arab2Rome(abs(year))+' ';
  if year < 1 then result := result+'B' else result := result+'A';
  result := result+'.S.';
end;


end.
