// DarkSpecter ZX Spectum Emulator
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
unit dspFModU;

interface

uses
  Windows, fmodtypes;


var
  FSOUND_Init: function (MixRate: Integer; MaxSoftwareChannels: Integer; Flags: Cardinal): ByteBool; stdcall;
  FSOUND_Close: procedure; stdcall;
  FSOUND_GetVersion: function (): Single; stdcall;
  FSOUND_SetOutput: function (OutputType: TFSoundOutputTypes): ByteBool; stdcall;
  FSOUND_SetDriver: function (Driver: Integer): ByteBool; stdcall;
  FSOUND_Stream_Create: function (Callback: TFSoundStreamCallback; Length: Integer; Mode: Cardinal; SampleRate: Integer; UserData: Integer): PFSoundStream; stdcall;
  FSOUND_Stream_Close: function (Stream: PFSoundStream): ByteBool; stdcall;
  FSOUND_Stream_Play: function (Channel: Integer; Stream: PFSoundStream): Integer; stdcall;
  FSOUND_Stream_Stop: function (Stream: PFSoundStream): ByteBool; stdcall;
  FSOUND_SetPaused: function (Channel: Integer; Paused: ByteBool): ByteBool; stdcall;

  saved8087CW: Word;


implementation


const
  FMOD_DLL = 'fmod.dll';


function Dummy_FSOUND_Init (MixRate: Integer; MaxSoftwareChannels: Integer; Flags: Cardinal): ByteBool; stdcall;
begin
  result := false;
end;

procedure Dummy_FSOUND_Close (); stdcall;
begin
end;

function Dummy_FSOUND_GetVersion (): Single; stdcall;
begin
  result := 0;
end;

function Dummy_FSOUND_SetOutput (OutputType: TFSoundOutputTypes): ByteBool; stdcall;
begin
  result := false;
end;

function Dummy_FSOUND_SetDriver (Driver: Integer): ByteBool; stdcall;
begin
  result := false;
end;

function Dummy_FSOUND_Stream_Create (Callback: TFSoundStreamCallback; Length: Integer; Mode: Cardinal; SampleRate: Integer; UserData: Integer): PFSoundStream; stdcall;
begin
  result := nil;
end;

function Dummy_FSOUND_Stream_Close (Stream: PFSoundStream): ByteBool; stdcall;
begin
  result := false;
end;

function Dummy_FSOUND_Stream_Play (Channel: Integer; Stream: PFSoundStream): Integer; stdcall;
begin
  result := 0;
end;

function Dummy_FSOUND_Stream_Stop (Stream: PFSoundStream): ByteBool; stdcall;
begin
  result := false;
end;

function Dummy_FSOUND_SetPaused (Channel: Integer; Paused: ByteBool): ByteBool; stdcall;
begin
  result := false;
end;


procedure GetAddress (handle: THandle; funcName: PChar; var ptr; def: Pointer);
var
  p: Pointer;
begin
  if handle = INVALID_HANDLE_VALUE then p := nil else p := GetProcAddress(handle, funcName);
  if p = nil then p := def;
  PPointer(@ptr)^ := p;
end;

procedure FMODLoad ();
var
  FMODHandle: THandle;
begin
  FMODHandle := LoadLibrary(FMOD_DLL);

  GetAddress(FMODHandle, '_FSOUND_Init@12', FSOUND_Init, @Dummy_FSOUND_Init);
  GetAddress(FMODHandle, '_FSOUND_Close@0', FSOUND_Close, @Dummy_FSOUND_Close);
  GetAddress(FMODHandle, '_FSOUND_GetVersion@0', FSOUND_GetVersion, @Dummy_FSOUND_GetVersion);
  GetAddress(FMODHandle, '_FSOUND_SetOutput@4', FSOUND_SetOutput, @Dummy_FSOUND_SetOutput);
  GetAddress(FMODHandle, '_FSOUND_SetDriver@4', FSOUND_SetDriver, @Dummy_FSOUND_SetDriver);
  GetAddress(FMODHandle, '_FSOUND_Stream_Create@20', FSOUND_Stream_Create, @Dummy_FSOUND_Stream_Create);
  GetAddress(FMODHandle, '_FSOUND_Stream_Close@4', FSOUND_Stream_Close, @Dummy_FSOUND_Stream_Close);
  GetAddress(FMODHandle, '_FSOUND_Stream_Play@8', FSOUND_Stream_Play, @Dummy_FSOUND_Stream_Play);
  GetAddress(FMODHandle, '_FSOUND_Stream_Stop@4', FSOUND_Stream_Stop, @Dummy_FSOUND_Stream_Stop);
  GetAddress(FMODHandle, '_FSOUND_SetPaused@8', FSOUND_SetPaused, @Dummy_FSOUND_SetPaused);
end;


initialization
  saved8087CW := Default8087CW;
  Set8087CW($133F); // disable all fpu exceptions
  FMODLoad();
finalization
  Set8087CW(saved8087CW);
end.
